Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.pattern
Class ContentTypeTest

    java.lang.Object
      net.sf.saxon.pattern.NodeTest
          net.sf.saxon.pattern.ContentTypeTest

All Implemented Interfaces:
  Serializable, ItemType

    public class ContentTypeTest

extends NodeTest

NodeTest is an interface that enables a test of whether a node matches particular conditions. ContentTypeTest tests for an element or attribute node with a particular type annotation.

Author:
  Michael H. Kay
See Also:
  Serialized Form

Constructor Summary
`ContentTypeTest(int nodeKind, SchemaType schemaType, Configuration config)` Create a ContentTypeTest

Method Summary
`boolean` | `equals(Object other)` Indicates whether some other object is "equal to" this one.
`AtomicType` | `getAtomizedItemType()` Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)
`SchemaType` | `getContentType()` Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes).
`double` | `getDefaultPriority()` Determine the default priority of this node test when used on its own as a Pattern
`int` | `getNodeKind()`
`int` | `getNodeKindMask()` Get a mask indicating which kinds of nodes this NodeTest can match.
`int` | `getPrimitiveType()` Determine the types of nodes to which this pattern applies.
`SchemaType` | `getSchemaType()`
`ItemType` | `getSuperType(TypeHierarchy th)` Get the type from which this item type is derived by restriction.
`int` | `hashCode()` Returns a hash code value for the object.
`boolean` | `isNillable()` The test is nillable if a question mark was specified as the occurrence indicator
`boolean` | `matches(int nodeKind, int fingerprint, int annotation)` Test whether this node test is satisfied by a given node
`boolean` | `matches(NodeInfo node)` Test whether this node test is satisfied by a given node.
`boolean` | `matches(TinyTree tree, int nodeNr)` Test whether this node test is satisfied by a given node on a TinyTree.
`boolean` | `matchesDTDTypes()` Test whether DTD-derived content types should be matched (the default is false)
`void` | `setMatchDTDTypes(boolean matched)` Indicate whether DTD-derived content types should be matched (the default is false)
`void` | `setNillable(boolean nillable)` Indicate whether nilled elements should be matched (the default is false)
`String` | `toString()`

Methods inherited from class net.sf.saxon.pattern.NodeTest
`getFingerprint, getPrimitiveItemType, getRequiredNodeNames, isAtomicType, matchesItem, toString`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ContentTypeTest

    public ContentTypeTest(int nodeKind,
                           SchemaType schemaType,
                           Configuration config)

  Create a ContentTypeTest

  Parameters:
    `nodeKind` - the kind of nodes to be matched: always elements or attributes
    `schemaType` - the required type annotation, as a simple or complex schema type
    `config` - the Configuration, supplied because this KindTest needs access to schema information

Method Detail

### setNillable

    public void setNillable(boolean nillable)

  Indicate whether nilled elements should be matched (the default is false)

  Parameters:
    `nillable` - true if nilled elements should be matched

### isNillable

    public boolean isNillable()

  The test is nillable if a question mark was specified as the occurrence indicator

  Overrides:
    `isNillable` in class `NodeTest`
  Returns:
    true if the test is nillable

### setMatchDTDTypes

    public void setMatchDTDTypes(boolean matched)

  Indicate whether DTD-derived content types should be matched (the default is false)

  Parameters:
    `matched` - true if DTD-derived types should be matched. If false, DTD-derived types are treated as untypedAtomic

### matchesDTDTypes

    public boolean matchesDTDTypes()

  Test whether DTD-derived content types should be matched (the default is false)

  Returns:
    true if DTD-derived types should be matched. If false, DTD-derived types are treated as untypedAtomic

### getSchemaType

    public SchemaType getSchemaType()

### getNodeKind

    public int getNodeKind()

### getSuperType

    public ItemType getSuperType(TypeHierarchy th)

  Description copied from class: `NodeTest`
  Get the type from which this item type is derived by restriction. This is the supertype in the XPath type heirarchy, as distinct from the Schema base type: this means that the supertype of xs:boolean is xs:anyAtomicType, whose supertype is item() (rather than xs:anySimpleType).

  In fact the concept of "supertype" is not really well-defined, because the types form a lattice rather than a hierarchy. The only real requirement on this function is that it returns a type that strictly subsumes this type, ideally as narrowly as possible.

  Specified by:
    `getSuperType` in interface `ItemType`
  Overrides:
    `getSuperType` in class `NodeTest`
  Returns:
    the supertype, or null if this type is item()

### matches

    public boolean matches(int nodeKind,
                           int fingerprint,
                           int annotation)

  Test whether this node test is satisfied by a given node

  Specified by:
    `matches` in class `NodeTest`
  Parameters:
    `nodeKind` - The type of node to be matched
    `fingerprint` - identifies the expanded name of the node to be matched
    `annotation` - The actual content type of the node

### matches

    public boolean matches(TinyTree tree,
                           int nodeNr)

  Test whether this node test is satisfied by a given node on a TinyTree. The node must be a document, element, text, comment, or processing instruction node. This method is provided so that when navigating a TinyTree a node can be rejected without actually instantiating a NodeInfo object.

  Specified by:
    `matches` in class `NodeTest`
  Parameters:
    `tree` - the TinyTree containing the node
    `nodeNr` - the number of the node within the TinyTree
  Returns:
    true if the node matches the NodeTest, otherwise false

### matches

    public boolean matches(NodeInfo node)

  Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.

  Specified by:
    `matches` in class `NodeTest`
  Parameters:
    `node` - the node to be matched

### getDefaultPriority

    public final double getDefaultPriority()

  Determine the default priority of this node test when used on its own as a Pattern

  Specified by:
    `getDefaultPriority` in class `NodeTest`

### getPrimitiveType

    public int getPrimitiveType()

  Determine the types of nodes to which this pattern applies. Used for optimisation.

  Specified by:
    `getPrimitiveType` in interface `ItemType`
  Overrides:
    `getPrimitiveType` in class `NodeTest`
  Returns:
    the type of node matched by this pattern. e.g. Type.ELEMENT or Type.TEXT

### getNodeKindMask

    public int getNodeKindMask()

  Get a mask indicating which kinds of nodes this NodeTest can match. This is a combination of bits: 1<
  Specified by:
    `getNodeKindMask` in class `NodeTest`

### getContentType

    public SchemaType getContentType()

  Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes). Return AnyType if there are no restrictions. The default implementation returns AnyType.

  Overrides:
    `getContentType` in class `NodeTest`

### getAtomizedItemType

    public AtomicType getAtomizedItemType()

  Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)

  Specified by:
    `getAtomizedItemType` in interface `ItemType`
  Overrides:
    `getAtomizedItemType` in class `NodeTest`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### hashCode

    public int hashCode()

  Returns a hash code value for the object.

  Overrides:
    `hashCode` in class `Object`

### equals

    public boolean equals(Object other)

  Indicates whether some other object is "equal to" this one.

  Overrides:
    `equals` in class `Object`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.